

soundPlayer = {

	IMG=0,

	window=0,

	sound=0,
	channel=0,
	volume=0.5,
	pan=0,
	ispaused=false,

	OpenFileCB = function( widget )

		-- get the filenames from the filedailog. Note that this dialog
		-- supports multiple files at the same time, this means that the function
		-- returns a table of files in an array.
		--
		local FileList ={};
		FileList = luiGetSelectedItems( widget ) ;

		-- Get the path to the file
		local Path = luiGetFilePath( widget );


		local FullFile = string.format("%s%s",Path,FileList[1]);

		if not soundPlayer.sound == 0 then
			Sound.Delete(soundPlayer.sound);
		end

		soundPlayer.sound = Sound.Load(FullFile);
		soundPlayer.channel = Sound.Play(soundPlayer.sound);
		Sound.SetPan( soundPlayer.channel, soundPlayer.pan );
		Sound.SetVolume( soundPlayer.channel, soundPlayer.volume );

	end,


	OnPlay = function( widget )

		soundPlayer.channel = Sound.Play(soundPlayer.sound);
		Sound.SetPan( soundPlayer.channel, soundPlayer.pan );
		Sound.SetVolume( soundPlayer.channel, soundPlayer.volume );

	end,

	OnStop = function( widget )

		Sound.Stop(soundPlayer.channel);
		soundPlayer.channel =0;

	end,

	OnPause = function( widget )

		if soundPlayer.ispaused then
			soundPlayer.ispaused  = false;
			Sound.UnPause(soundPlayer.channel);
		else
			soundPlayer.ispaused  = true;
			Sound.Pause(soundPlayer.channel);
		end
	end,

	OnOpen = function()


		luiFileDialog {
			label = "sound file to play",
			name = "soundFileDialog",
			x = 420,
			y = 100,
			w = 250,
			h = 500,
			command="soundPlayer.OpenFileCB"
		};

	end,

	----------------------------------------
	-- This function is called when the user changes the volume
	--
	OnVolumeChanged = function( name )
		soundPlayer.volume = luiGetFloat( name );
		Sound.SetVolume( soundPlayer.channel, soundPlayer.volume );

	end,
	----------------------------------------
	-- This function is called when the user changes the volume
	--
	OnPanChanged = function( name )
		soundPlayer.pan = luiGetFloat( name );
		Sound.SetPan( soundPlayer.channel, soundPlayer.pan );

	end,

	OnCreate = function()

		soundPlayer.window = luiWindow {
			label = "SoundPlayer",
			name = "soundPlayerWindow",
			x = 50,
			y = 50,
			w = 160,
			h = 80
		}
			luiIconButton {
				name = "OpenImageButton",
				w = 20,
				h = 20,
				x = 2,
				y = 2,
				icon = ICON_OPEN,
				command = "soundPlayer.OnOpen"
			}

			luiArrowButton {
				name = "PlayAviButton",
				x = 22,
				y = 2,
				w = 20,
				h = 20,
				command = "soundPlayer.OnPlay",
				dir = LUI_RIGHT
			}

			luiArrowButton {
				name = "StopAviButton",
				x = 44,
				y = 2,
				w = 20,
				h = 20,
				command = "soundPlayer.OnStop",
				dir = LUI_STOP
			}

			luiArrowButton {
				name = "PauseAviButton",
				x = 66,
				y = 2,
				w = 20,
				h = 20,
				command = "soundPlayer.OnPause",
				dir = LUI_PAUSE
			}

			luiFloatSlider {
				label="Volume",
				value=0.5,
				x = 5,
				y = 25,
				w = 80,
				h = 25,
				command = "soundPlayer.OnVolumeChanged"
			}
			luiFloatSlider {
				label="Pan",
				min=-1,
				max=1,
				value=0,
				x = 5,
				y = 55,
				w = 80,
				h = 25,
				command = "soundPlayer.OnPanChanged"
			}
	end
}

soundPlayer.OnCreate();
